﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
        }

        private void XamDataGrid_CellActivated(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs e)
        {
            // Workaround for the ComboBox behavior when navigating with keyboard arrows through the disabled combo items.
            // Item containers are not generated until dropdown is opened at least once. 
            // Workaround is based on the following blog post:
            // https://blog.elgaard.com/2009/09/03/wpf-making-combo-box-items-disabled-also-when-accessed-using-the-keyboard/

            Dispatcher.BeginInvoke(new Action(() =>
            {
                if (e.Cell.Field.Name == "SocialSecurityNumber")
                {
                    (CellValuePresenter.FromCell(e.Cell).Editor as XamComboEditor).IsDropDownOpen = true;
                    (CellValuePresenter.FromCell(e.Cell).Editor as XamComboEditor).IsDropDownOpen = false;
                }
            }), System.Windows.Threading.DispatcherPriority.Background, null);
        }
    }

    public class Data
    {
        public ObservableCollection<ComboItem> ListOfSSNItemsProvider { get; set; }

        public ObservableCollection<Item> DataCollection { get; set; }


        public Data()
        {
            ListOfSSNItemsProvider = new ObservableCollection<ComboItem>()
                                     {
                                         new ComboItem() { SocialSecurityNumber = "1111-1111-11111-111" , IsItemEnabled = true } ,
                                         new ComboItem() { SocialSecurityNumber = "1112-1112-11112-112", IsItemEnabled = false },
                                         new ComboItem() { SocialSecurityNumber = "2111-1131-11151-811", IsItemEnabled = true }
                , 
                                     };

            DataCollection = new ObservableCollection<Item>()
                             {
                                 new Item() { SocialSecurityNumber = "1111-1111-11111-111"},
                                 new Item() { SocialSecurityNumber = "2111-1131-11151-811"}
                             };
        }
    }

    public class Item : INotifyPropertyChanged
    {
        public string SocialSecurityNumber { get; set; }
        

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }

    public class ComboItem : INotifyPropertyChanged
    {
        public string SocialSecurityNumber { get; set; }
        private bool _isItemEnabled;
        public bool IsItemEnabled
        {
            get { return _isItemEnabled; }
            set
            {
                _isItemEnabled = value;
                OnPropertyChanged("IsItemEnabled");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
